.586
.model flat,stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib

include \masm32\macros\macros.asm

.data
	ClassName	db "DLGCLASS",0
	DlgName		db "MyDialog",0
	MenuName	db "File",0

.data?
	hInstance	HINSTANCE ?
	CommandLine	LPSTR ?
	hDlg		dd ?
	hEdit1		dd ?
	hCLEARCHAR	dd ?
	hEXIT		dd ?

.const
	IDC_EDIT1	equ 3000
	IDC_CLEARCHAR	equ 110
	IDC_EXIT	equ 111

.code

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG

	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,DLGWINDOWEXTRA
	push  hInst
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_BTNFACE+1
	mov   wc.lpszMenuName, OFFSET MenuName
	mov   wc.lpszClassName,OFFSET ClassName
	invoke LoadIcon,hInstance,200
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax

	invoke RegisterClassEx, addr wc

	invoke CreateDialogParam,hInstance,ADDR DlgName,NULL,NULL,NULL
	mov   hDlg,eax

	INVOKE ShowWindow, hDlg,SW_SHOWNORMAL
	INVOKE UpdateWindow, hDlg
	.WHILE TRUE
                INVOKE GetMessage, ADDR msg,NULL,0,0
                .BREAK .IF (!eax)
                invoke IsDialogMessage, hDlg, ADDR msg
                .if eax==FALSE
                        INVOKE TranslateMessage, ADDR msg
                        INVOKE DispatchMessage, ADDR msg
                .endif
	.ENDW
	mov     eax,msg.wParam
	ret
WinMain endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	lOCAL dwWidth,dwHeight:DWORD

	.if uMsg==WM_CREATE

	.ELSEIF uMsg==WM_DESTROY || uMsg==WM_CLOSE
		
		invoke PostQuitMessage,NULL

	.ELSEIF uMsg==WM_COMMAND
		
		.if word ptr [wParam]==IDC_CLEARCHAR
			invoke	SendMessage, hEdit1,EM_SETSEL,0,8192
			invoke	SendMessage, hEdit1,WM_CLEAR,0,0
		.elseif word ptr [wParam]==IDC_EXIT 
			invoke SendMessage,hWnd,WM_CLOSE,NULL,NULL
		.endif

	.elseif uMsg==WM_SHOWWINDOW

		invoke GetDlgItem, hWnd, IDC_EDIT1
		mov hEdit1, eax
		invoke GetDlgItem,hWnd,IDC_CLEARCHAR
		mov hCLEARCHAR, eax
		invoke GetDlgItem,hWnd,IDC_EXIT
		mov hEXIT, eax

	.ELSEIF uMsg==WM_SIZE
		mov     eax, lParam     ; Height/width of new window
		mov     ebx, eax
		and     ebx, 0000ffffh  ; ebx = LOWORD(lparam) = width(largeur)
		shr     eax, 16         ; eax = HIWORD(lparam) = height(longueur)

		mov dwWidth, EBX
		mov dwHeight, EAX

		sub ebx,38
		sub eax,58
		
		invoke MoveWindow, hEdit1, 20, 20, ebx, eax, TRUE
		
		mov EBX,dwWidth
		mov EAX,dwHeight
		SUB EBX,200
		SUB EAX,28
		
		invoke MoveWindow, hCLEARCHAR, EBX, EAX, 90, 24, TRUE

		mov EBX,dwWidth
		mov EAX,dwHeight
		SUB EBX,100
		SUB EAX,28
		
		invoke MoveWindow, hEXIT, EBX, EAX, 90, 24, TRUE
	.ELSE
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.ENDIF
	xor    eax,eax
	ret
WndProc endp

Start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	invoke GetCommandLine
	mov CommandLine,eax
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax

end Start

